﻿using Borepin.Base;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;

namespace Borepin.PageModel
{
    public class BorpinMasterDetailPageModel : PageModelBase
    {
        public BorpinMasterDetailPageModel(BorpinMasterPageModel borpinMasterPM, MachinesPageModel machinesPM, SettingsPageModel settingsPM)
        {
            BorpinMasterPM = borpinMasterPM;
            MachinesPM = machinesPM;
            SettingsPM = settingsPM;
        }

        private BorpinMasterPageModel _BorpinMasterPM;
        public BorpinMasterPageModel BorpinMasterPM
        {
            get => _BorpinMasterPM;
            set => SetProperty(ref _BorpinMasterPM, value);
        }

        private MachinesPageModel _MachinesPM;
        public MachinesPageModel MachinesPM
        {
            get => _MachinesPM;
            set => SetProperty(ref _MachinesPM, value);
        }

        private SettingsPageModel _SettingsPM;
        public SettingsPageModel SettingsPM
        {
            get => _SettingsPM;
            set => SetProperty(ref _SettingsPM, value);
        }

        public override Task InitializeAsync(object navigationData)
        {
            return Task.WhenAny(
                base.InitializeAsync(navigationData),
                BorpinMasterPM.InitializeAsync(null),
                MachinesPM.InitializeAsync(null),
                SettingsPM.InitializeAsync(null));
        }
    }
}
