﻿using Borepin.Base;
using Borepin.Page;
using Borepin.Service.Navigation;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using System.Xml.Schema;
using Xamarin.Forms;

namespace Borepin.PageModel
{
    public class BorpinMasterPageModel : PageModelBase
    {
        private INavigationService _NavigationService;

        public BorpinMasterPageModel(INavigationService navigationService)
        {
            _NavigationService = navigationService;
            MasterMenu = new ObservableCollection<MasterMenuItem>()
            {
                new MasterMenuItem{ Id = 0, Title = "Machines" },
                new MasterMenuItem{ Id = 1, Title = "Settings" }
            };

            _showDetailPageAsyncCommand = new Command(ShowDetailPageAsync);
        }

        private ObservableCollection<MasterMenuItem> _MasterMenu;
        public ObservableCollection<MasterMenuItem> MasterMenu
        {
            get => _MasterMenu;
            set => SetProperty(ref _MasterMenu, value);
        }

        private MasterMenuItem _MasterMenu_ItemSelected;
        public MasterMenuItem MasterMenu_ItemSelected
        {
            get => _MasterMenu_ItemSelected;
            set => SetProperty(ref _MasterMenu_ItemSelected, value);
        }

        private ICommand _showDetailPageAsyncCommand;
        public ICommand ShowDetailPageAsyncCommand
        {
            get => _showDetailPageAsyncCommand;
            set => SetProperty(ref _showDetailPageAsyncCommand, value);
        }
        private async void ShowDetailPageAsync()
        {
            switch (MasterMenu_ItemSelected.Title)
            {
                case "Machines":
                    await _NavigationService.NaviagteToAsync<MachinesPageModel>();
                    break;
                case "Settings":
                    await _NavigationService.NaviagteToAsync<SettingsPageModel>();
                    break;
                default:
                    break;
            }

            if (Application.Current.MainPage is MasterDetailPage masterDetailPage)
            {
                masterDetailPage.IsPresented = false;
            }
            else if (Application.Current.MainPage is NavigationPage navigationPage
                     && navigationPage.CurrentPage is MasterDetailPage nestedMasterDetail)
            {
                nestedMasterDetail.IsPresented = false;
            }
        }
    }
}
