﻿using Borepin.Base;
using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace Borepin.Service.Navigation
{
    public class NavigationService : INavigationService
    {
        public Task GoBackAsync()
        {
            return App.Current.MainPage.Navigation.PopAsync();
        }

        public async Task NaviagteToAsync<TPageModelBase>(object navigationData = null, bool setRoot = false)
        {
            Xamarin.Forms.Page page = PageModelLocator.CreatePage(typeof(TPageModelBase));
            if(setRoot)
            {
                if (page is TabbedPage tabbedPage)
                {
                    App.Current.MainPage = tabbedPage;
                }
                else if(page is MasterDetailPage masterDetailPage)
                {
                    App.Current.MainPage = masterDetailPage;
                }
                else
                {
                    App.Current.MainPage = new NavigationPage(page);
                }
            }
            else
            {
                if (App.Current.MainPage is MasterDetailPage masterDetailPage)
                {
                    masterDetailPage.Detail = new NavigationPage(page);
                }

                if (App.Current.MainPage is NavigationPage navPage)
                {
                    await navPage.PushAsync(page);
                }
                else
                {
                    App.Current.MainPage = new NavigationPage(page);
                }
            }

            if(page.BindingContext is PageModelBase pmBase)
            {
                await pmBase.InitializeAsync(navigationData);
            }
        }
    }
}
